// CaddyVMCompiler.cpp : Defines the entry point for the console application.
//

//
// When compiling, output a .MAP file that lists the mem location
// of each instruction
//

#include "stdafx.h"
#include "assembler.h"

#include <stdio.h>

const char* version = "1.0";

int main(int argc, char** argv)
{
    printf("------------------------\n");
    printf("CaddyVM Assembler v%s\n", version);
    printf("------------------------\n");
    printf("September 2003\n\n");

    if(argc < 3)
    {
        printf("Invalid arguments!\nUsage: CaddyVMCompiler <filename> <out filename>\n\n");
        return 1;
    }

    printf("Opening %s\n", argv[1]);
    
    Assembler assembler;
    assembler.Init(argv[1]);
    int res = assembler.Assemble();
    
    if(res == 0)
    {
        assembler.Save(argv[2]);
        printf("Assembly Complete(%s)\n", argv[2]);
    }
    else
    {
        printf("Assembly Failure!\n");
    }

	return 0;
}

