#include "stdafx.h"
#include "asmreader.h"
#include "stringtokenizer.h"

#include <stdio.h>

AsmReader::AsmReader(const char* pFilename):
m_iCurLine(0)
{
    m_pFileHandle = fopen(pFilename, "r");
    if(NULL != m_pFileHandle)
    {
        // do we need to do something here?
    }
}

AsmReader::~AsmReader()
{
    if(NULL != m_pFileHandle)
    {
        fclose(m_pFileHandle);
    }
}

void AsmReader::GetLine(AsmArgs* pArgs)
{
    if(NULL == pArgs)
    {
        return;
    }

    bool bFinished = false;
    pArgs->argc = 0;

    if(NULL != m_pFileHandle)
    {
        while(!bFinished)
        {
            char line[MAX_LINE_SIZE];
            memset(line, 0 ,MAX_LINE_SIZE);
            fgets(line, MAX_LINE_SIZE -1, m_pFileHandle);
            if( (!feof(m_pFileHandle)) && (!ferror(m_pFileHandle)) )
            {
                ++m_iCurLine;

                if((line[0] == ';') || (line[0] == ' ') || (line[0] == '\n') || (line[0] == '\r'))
                {
                    continue;
                }

                StringTokenizer ST(line, " ,\r\n");
                ST.SetStopChar(';');

                for(int i = 0; ST.hasMoreTokens();i++)
                {
                    if(i >= 3)
                    {
                        bFinished = true;
                        break;
                    }

                    char* token = ST.nextToken();
                    if(token[0] != '\0')
                    {
                        strncpy(pArgs->argv[i], token, 255);
                        pArgs->argc++;
                    }
                    else
                    {
                        bFinished = true;
                        //break;
                    }
                }
                bFinished = true;

            }
            else
            {
                //pArgs->argc = 0;
                bFinished = true;
                return;
            }
        }
    }
    else
    {
       pArgs->argc = 0;
    }
}