#ifndef _ASSEMBLER_H_
#define _ASSEMBLER_H_

// Forward declarations
class AsmReader;
struct AsmArgs;

#define MEMORY_SIZE 1024*64

enum EArgType
{
    ARG_TYPE_REGISTER = 0,
    ARG_TYPE_HEX = 1,
    ARG_TYPE_MEMORY = 1,
    ARG_TYPE_INVALID = 2
};

class Assembler
{
public:
    Assembler();
    ~Assembler();
    void Init(const char* pFilename);
    int  Assemble();
    void Save(const char* pFilename);

protected:
    int  HandleLine(AsmArgs* pArgs);
    int  HandleOpcodeMOV(AsmArgs* pArgs);
    int  HandleOpcodeMVI(AsmArgs* pArgs);
    int  HandleOpcodeADD(AsmArgs* pArgs);
    int  HandleOpcodeCMP(AsmArgs* pArgs);
    int  HandleOpcodeRET(AsmArgs* pArgs);
    int  ConvertReg(char cReg);
    int  GetArgType(AsmArgs* pArgs, int iIndex);
    void SaveToMemory(uint8 data);

    AsmReader* m_pReader;

    //This represents the memory in the VM
    unsigned char m_Memory[MEMORY_SIZE];
    int m_MemoryCounter;

};

#endif
